/*

 path.h - A mostly working PCLink server for IDEDOS 0.9x

 Written by
  Kajtar Zsolt <soci@c64.rulez.org>

    This file is part of IDEDOS the IDE64 disk operating system
    See README for copyright notice.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _PATH_H
#define _PATH_H
#include <stdio.h>
#include <wchar.h>
#include "ideserv.h"

typedef struct {
    c64c_t name[16];
    unsigned char filesize[4];
    unsigned char pointer[4];
    unsigned char attrib;
    c64c_t filetype[3];
    unsigned char time[4];
} __attribute((packed)) DIRECTORY_ENTRY_T;

#define A_CLOSED      0x80
#define A_DELETEABLE  0x40
#define A_READABLE    0x20
#define A_WRITEABLE   0x10
#define A_EXECUTEABLE 0x08
#define A_DEL         0x00
#define A_NORMAL      0x01
#define A_REL         0x02
#define A_DIR         0x03
#define A_LNK         0x04
#define A_ANY         0x07

extern int createdirentry(const char *, const char *, DIRECTORY_ENTRY_T *, int);
extern void initdirentry(int);
extern void convertfilename(const c64c_t *, char, c64c_t *, c64c_t *, unsigned char *);
extern int matchname(c64c_t *, c64c_t *);
extern int resolv_path(const c64c_t *, char *, const c64c_t **, unsigned char *, FILE *, int);
extern size_t c64toascii(char *, c64c_t, mbstate_t *);
#endif
